package com.nisum.paymentvendorsimulator.paypal.controllers;

import com.nisum.paymentvendorsimulator.exceptions.BaseController;
import com.nisum.paymentvendorsimulator.exceptions.PayPalTestException;
import com.nisum.paymentvendorsimulator.paypal.domain.dto.PayPalResponse;
import com.nisum.paymentvendorsimulator.paypal.services.PayPalService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/api/paypal")
@CrossOrigin(origins = "*")
public class PayPalController extends BaseController {

  private static final Logger logger = LoggerFactory.getLogger(PayPalController.class);

  @Autowired
  PayPalService ppService;

  @PostMapping(value = "/authorize/{id}", consumes = MediaType.APPLICATION_JSON_VALUE, produces = MediaType.APPLICATION_JSON_VALUE)
  public PayPalResponse authorize(@PathVariable(value = "id") String id) {
    logger.info("this is PayPal Controller");
    if(id.equals("123")) throw new PayPalTestException();
    return ppService.authorize(id);
  }

}
